package hage;

import haxe.ds.GenericStack;

/**
 * ...
 * @author JanGamesCo
 */
class HGEPool extends HGEBasic
{
	private var deads:GenericStack<HGEBasic>;
	private var alives:GenericStack<HGEBasic>;

	public function new()
	{
		super();
		
		deads = new GenericStack();
		alives = new GenericStack();
	}
	
	/*public function getAlive()
	{
		for (child in deads) {
			return child;
		}
		
		for (child in childrens) {
			if (child.exists == false) {
				return;
			}
		}
		
		return createChild();
	}*/
	
	public function getDead():HGEBasic
	{
		if (deads.isEmpty()) {
			return createChild();
		} else {
			return deads.pop();
		}
	}
	
	public function createChild() {
		var basic:HGEBasic = new HGEBasic();
		add(basic);
		return basic;
	}
	
	public function killChild(Child:HGEBasic)
	{
		deads.add(Child);
		Child.kill();
	}
	
	override public function reset():Void 
	{
		//Kill all
		while (!alives.isEmpty()) {
			var basic:HGEBasic = alives.pop();
			basic.kill();
			deads.add(basic);
		}
	}
	
}