package hage;
import hage.HGEBasic;

/**
 * ...
 * @author JanGamesCo
 */
class HGEGroup extends HGEBasic
{
	public var alive(get, default):Int;
	public var dead(get, default):Int;

	public function new() 
	{
		reset();
	}
	
	override public function add(Child:HGEBasic):Void 
	{
		if (Child.exists) { alive++; }
		
		super.add(Child);
	}
	
	override public function reset():Void 
	{
		super.reset();
	}
	
	private function get_alive():Int {
		var i:Int = 0;
		for (basic in childrens) {
			if (basic.exists) { i++; }
		}
		return i;
	}
	private function get_dead():Int { return childrens.length - alive; }
	
}